#! ruby -Ks
# naiiv_rename.rb ver 1.3: Ȃ[ԃlbgȂ܂ύX  2010.04.12@@TsGɑΉ
# Copyright (C) T. Yoshiizumi, 2008-2010 All rights reserved.
require 'win32ole'
require 'Win32API'
require 'fileutils.rb'

# methods
def get_fname(w)  # t@C{́{gq𒊏o
  return File.basename(w)
end

def get_path(w)  # pX𒊏o
  r = File.dirname(w)
  if r =~ /\:$/
    r = sprintf("%s\\", r)
  end
  return r
end

def get_body(w)  # gqԂ
  r = File.dirname(w) + "\\" + File.basename(w, ".*")
  return r
end

def get_ext(w)
  return  File.extname(w)
end

# t@ClenoCgxɒZk
def cut_fname(fname, len)
  wlist = fname.split(/ +/)
  wstr = ''
  for i in wlist
    wstr = sprintf("%s%s", wstr, i)
    if wstr.size > len
      break
    end
    wstr = sprintf("%s ", wstr)
  end
  wstr.sub!(/ +$/, "")
  return wstr
end

# t@CbtH_̖OƂĎgȂpSpɒu
def fname_arrange(ff)
  ff = ff.gsub(/\*/, "")
  ff.gsub!(/\?/, "H")
  ff.gsub!(/\|/, "b")
  ff.gsub!(/\</, "")
  ff.gsub!(/\>/, "")
  ff.gsub!(/\//, "^")
  ff.gsub!(/\\/, "")
  ff.gsub!(/\%/, "")
  ff.gsub!(/([-])-([-])/, "\\1\\2")
  return ff
end

# t@CύX̂߂̃\bh
def file_rename(bd)
  f_count = 0
  old_name = get_fname(bd)
  detail = sprintf("%s\\detail.txt", bd)
  infile = open(detail)
  new_name = infile.gets
  infile.close
  new_name.chomp!
  new_name = fname_arrange(new_name)
  new_name.gsub!(/@+/, " ")
  short_name = cut_fname(new_name, 12)
  Dir.chdir(bd)
  list = Dir.glob('*')
  for fname in list
    if fname =~ /^(.+)-([0-9]+)(\.[A-Za-z]+)$/
      b1 = $1
      b2 = sprintf("%02d", $2.to_i)
      ext = $3
      fname2 = sprintf("%s %s %s", short_name, b2, ext)
      unless test(?e, fname2)
        FileUtils.mv(fname, fname2)
        f_count += 1
      end
    end
  end
  if f_count > 0
    return f_count
  end

  flist = []
  infile = open(detail)
  infile.each { |line|
    line = line.chomp
    line = line.gsub(/^( |\t|@)+/, "")
    line = line.gsub(/( |\t|@)+$/, "")
    if line =~ /^([0-9]+)\/[0-9]+ +(.+\.[A-Za-z]+)$/
      flist[$1.to_i - 1] = $2
    end
  }
  infile.close
  for fname in list
    i = -1
    j = -1
    for w in flist
      i += 1
      if get_body(fname).downcase == get_body(w).downcase
        j = i
        break
      end
    end
    if j >= 0
      fname2 = sprintf("%s %02d %s", short_name, j+1, get_ext(fname))
      unless test(?e, fname2)
        FileUtils.mv(fname, fname2)
        f_count += 1
      end
    end
  end
  return f_count
end

## main
wsh = WIN32OLE.new("WScript.Shell")
# $beep = Win32API::new('kernel32', 'Beep', ['i', 'i'], 'i')
unzip_dll = "UNZIP32.DLL"
arch = Win32API.new(unzip_dll, 'UnZip', 'LPPI', 'I')
running = Win32API.new(unzip_dll, 'UnZipGetRunning', '', 'I')
parent_dir = ''
count = 0
file_count = 0
argv_count = ARGV.size

wargv = ARGV.dup
for base_dir in wargv
  # tH_łꍇ
  if test(?d, base_dir)
    detail = sprintf("%s\\detail.txt", base_dir)
    if test(?e, detail)
      infile = open(detail)
      new_dir = infile.gets
      infile.close
      new_dir.chomp!
      new_dir.sub!(/( |@)+[0-9]+[^ 0-9@]+~[0-9]+.+$/, "")
      new_dir = fname_arrange(new_dir)
      new_dir = cut_fname(new_dir, 30)
      old_dir = get_fname(base_dir).sub(/_+$/, "")
      parent_dir = get_path(base_dir)
      unless old_dir == new_dir
        Dir.chdir(parent_dir)
        unless test(?e, new_dir)
          count += 1
          FileUtils.mv(old_dir, new_dir)
          file_count += file_rename(new_dir)
          puts file_count
          # $beep.call(220, 50)
        else  #  new_dir ݂ꍇ
          new_dir = new_dir + "_"
          while test(?e, new_dir)
            new_dir = new_dir + "_"
          end
          count += 1
          FileUtils.mv(old_dir, new_dir)
          file_count += file_rename(new_dir)
          puts file_count
          # $beep.call(220, 50)
        end
      end
    end
    next
  end

  # tH_łȂꍇ
  if test(?e, base_dir) and get_fname(base_dir.downcase) =~ /^.+\.(exe|zip)$/
    fname = get_fname(base_dir)
    body = get_body(fname)
    parent_dir = get_path(base_dir)
    Dir.chdir(parent_dir)
    if test(?d, body)
      FileUtils.rm(base_dir)
      next
    end
    if test(?e, body)
      FileUtils.rm(body)
    end
    while running.call() != 0
      wdummy = ''
    end
    cmd = sprintf("--i -qq -x \"%s\"", base_dir)
    res = "\x00" * 4096
    if arch.call(-1, cmd, res, 4096) == 0
      FileUtils.rm(base_dir)
      wargv << get_body(base_dir)
    end
  end
end
while running.call() != 0
  wdummy = ''
end

if (count+file_count) > 0
  w = sprintf("%d̃tH_C%d̃t@C̖OύX܂D",
      count, file_count)
else
  if argv_count == 0
    w = "naiiv_rename version 1.2: ׂtH_̎w肪܂D"
  else
    w = "O̕ύX͍s܂łD"
  end
end
wsh.Popup(w, 12, 'Ȃ[ԃlbgȂ܂ύX', 0)
